Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2823)
@@ -6,4 +6,5 @@
    !! History :   1.0  !  2004-03 (O. Aumont) Original code
    !!             2.0  !  2007-12  (C. Ethe, G. Madec)  F90
+   !!             3.4  !  2011-06  (O. Aumont, C. Ethe) USE of fldread
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -15,15 +16,16 @@
    !!   p4z_sed_init   :  Initialization of p4z_sed
    !!----------------------------------------------------------------------
-   USE trc
-   USE oce_trc         !
-   USE sms_pisces
-   USE prtctl_trc
-   USE p4zbio
-   USE p4zint
-   USE p4zopt
-   USE p4zsink
-   USE p4zrem
-   USE p4zlim
-   USE iom
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zlim          !  Co-limitations of differents nutrients
+   USE p4zrem          !  Remineralisation of organic matter
+   USE p4zint          !  interpolation and computation of various fields
+   USE iom             !  I/O manager
+   USE fldread         !  time interpolation
+   USE prtctl_trc      !  print control for debugging
+
 
 
@@ -36,26 +38,33 @@
 
    !! * Shared module variables
-   LOGICAL, PUBLIC :: ln_dustfer  = .FALSE.    !: boolean for dust input from the atmosphere
-   LOGICAL, PUBLIC :: ln_river    = .FALSE.    !: boolean for river input of nutrients
-   LOGICAL, PUBLIC :: ln_ndepo    = .FALSE.    !: boolean for atmospheric deposition of N
-   LOGICAL, PUBLIC :: ln_sedinput = .FALSE.    !: boolean for Fe input from sediments
-
-   REAL(wp), PUBLIC :: sedfeinput = 1.E-9_wp   !: Coastal release of Iron
-   REAL(wp), PUBLIC :: dustsolub  = 0.014_wp   !: Solubility of the dust
+   LOGICAL  :: ln_dust     = .FALSE.    !: boolean for dust input from the atmosphere
+   LOGICAL  :: ln_river    = .FALSE.    !: boolean for river input of nutrients
+   LOGICAL  :: ln_ndepo    = .FALSE.    !: boolean for atmospheric deposition of N
+   LOGICAL  :: ln_ironsed  = .FALSE.    !: boolean for Fe input from sediments
+
+   REAL(wp) :: sedfeinput  = 1.E-9_wp   !: Coastal release of Iron
+   REAL(wp) :: dustsolub   = 0.014_wp   !: Solubility of the dust
+   REAL(wp) :: wdust       = 2.0_wp     !: Sinking speed of the dust 
+   REAL(wp) :: nitrfix     = 1E-7_wp    !: Nitrogen fixation rate   
+   REAL(wp) :: diazolight  = 50._wp     !: Nitrogen fixation sensitivty to light 
+   REAL(wp) :: concfediaz  = 1.E-10_wp  !: Fe half-saturation Cste for diazotrophs 
+
 
    !! * Module variables
    REAL(wp) :: ryyss                  !: number of seconds per year 
-   REAL(wp) :: ryyss1                 !: inverse of ryyss
+   REAL(wp) :: r1_ryyss                 !: inverse of ryyss
    REAL(wp) :: rmtss                  !: number of seconds per month
-   REAL(wp) :: rday1                  !: inverse of rday
-
-   INTEGER , PARAMETER :: jpmth = 12  !: number of months per year
-   INTEGER , PARAMETER :: jpyr  = 1   !: one year
-
-   INTEGER ::  numdust                !: logical unit for surface fluxes data
-   INTEGER ::  nflx1 , nflx2          !: first and second record used
-   INTEGER ::  nflx11, nflx12
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: dustmo    !: set of dust fields
+   REAL(wp) :: r1_rday                  !: inverse of rday
+   LOGICAL  :: ll_sbc
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_dust      ! structure of input dust
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_riverdic  ! structure of input riverdic
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_riverdoc  ! structure of input riverdoc
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_ndepo     ! structure of input nitrogen deposition
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_ironsed   ! structure of input iron from sediment
+
+   INTEGER , PARAMETER :: nbtimes = 365  !: maximum number of times record in a file
+   INTEGER  :: ntimes_dust, ntimes_riv, ntimes_ndep       ! number of time steps in a file
+
    REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: dust      !: dust fields
    REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: rivinp, cotdep    !: river input fields
@@ -86,6 +95,7 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY: zsidep => wrk_2d_1, zwork => wrk_2d_2, zwork1 => wrk_2d_3
+      USE wrk_nemo, ONLY: wrk_in_USE, wrk_not_released
+      USE wrk_nemo, ONLY: zsidep   => wrk_2d_11
+      USE wrk_nemo, ONLY: zwork1   => wrk_2d_12, zwork2 => wrk_2d_13, zwork3 => wrk_2d_14
       USE wrk_nemo, ONLY: znitrpot => wrk_3d_2, zirondep => wrk_3d_3
       !
@@ -96,23 +106,25 @@
       REAL(wp) ::   zrivalk, zrivsil, zrivpo4
 #endif
-      REAL(wp) ::   zdenitot, znitrpottot, zlim, zfact
-      REAL(wp) ::   zwsbio3, zwsbio4, zwscal
+      REAL(wp) ::   zdenitot, znitrpottot, zlim, zfact, zfactcal
+      REAL(wp) ::   zsiloss, zcaloss, zwsbio3, zwsbio4, zwscal, zdep
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
-      IF( ( wrk_in_use(2, 1,2,3) ) .OR. ( wrk_in_use(3, 2,3) ) ) THEN
+      IF( ( wrk_in_USE(2, 11,12,13,14) ) .OR. ( wrk_in_USE(3, 2,3) ) ) THEN
          CALL ctl_stop('p4z_sed: requested workspace arrays unavailable')  ;  RETURN
       END IF
 
-      IF( jnt == 1  .AND.  ln_dustfer  )  CALL p4z_sbc( kt )
+      IF( jnt == 1 .AND. ll_sbc ) CALL p4z_sbc( kt )
+
+      zirondep(:,:,:) = 0.e0          ! Initialisation of variables USEd to compute deposition
+      zsidep  (:,:)   = 0.e0
 
       ! Iron and Si deposition at the surface
       ! -------------------------------------
-
       DO jj = 1, jpj
          DO ji = 1, jpi
-            zirondep(ji,jj,1) = ( dustsolub * dust(ji,jj) / ( 55.85 * rmtss ) + 3.e-10 * ryyss1 )   &
-               &             * rfact2 / fse3t(ji,jj,1)
-            zsidep  (ji,jj)   = 8.8 * 0.075 * dust(ji,jj) * rfact2 / ( fse3t(ji,jj,1) * 28.1 * rmtss )
+            zdep  = rfact2 / fse3t(ji,jj,1)
+            zirondep(ji,jj,1) = ( dustsolub * dust(ji,jj) / ( 55.85 * rmtss ) + 3.e-10 * r1_ryyss ) * zdep
+            zsidep  (ji,jj)   = 8.8 * 0.075 * dust(ji,jj) * zdep / ( 28.1 * rmtss )
          END DO
       END DO
@@ -120,12 +132,10 @@
       ! Iron solubilization of particles in the water column
       ! ----------------------------------------------------
-
       DO jk = 2, jpkm1
-         zirondep(:,:,jk) = dust(:,:) / ( 10. * 55.85 * rmtss ) * rfact2 * 1.e-4
+         zirondep(:,:,jk) = dust(:,:) / ( wdust * 55.85 * rmtss ) * rfact2 * 1.e-4 * EXP( -fsdept(:,:,jk) / 1000. )
       END DO
 
       ! Add the external input of nutrients, carbon and alkalinity
       ! ----------------------------------------------------------
-
       trn(:,:,1,jppo4) = trn(:,:,1,jppo4) + rivinp(:,:) * rfact2 
       trn(:,:,1,jpno3) = trn(:,:,1,jpno3) + (rivinp(:,:) + nitdep(:,:)) * rfact2
@@ -139,9 +149,7 @@
       ! (dust, river and sediment mobilization)
       ! ------------------------------------------------------
-
       DO jk = 1, jpkm1
          trn(:,:,jk,jpfer) = trn(:,:,jk,jpfer) + zirondep(:,:,jk) + ironsed(:,:,jk) * rfact2
       END DO
-
 
 #if ! defined key_sed
@@ -154,77 +162,86 @@
             ikt = mbkt(ji,jj) 
 # if defined key_kriest
-            zwork (ji,jj) = trn(ji,jj,ikt,jpdsi) * wscal (ji,jj,ikt)
-            zwork1(ji,jj) = trn(ji,jj,ikt,jppoc) * wsbio3(ji,jj,ikt)
+            zwork1(ji,jj) = trn(ji,jj,ikt,jpdsi) * wscal (ji,jj,ikt)
+            zwork2(ji,jj) = trn(ji,jj,ikt,jppoc) * wsbio3(ji,jj,ikt)
 # else
-            zwork (ji,jj) = trn(ji,jj,ikt,jpdsi) * wsbio4(ji,jj,ikt)
-            zwork1(ji,jj) = trn(ji,jj,ikt,jpgoc) * wsbio4(ji,jj,ikt) + trn(ji,jj,ikt,jppoc) * wsbio3(ji,jj,ikt) 
+            zwork1(ji,jj) = trn(ji,jj,ikt,jpdsi) * wsbio4(ji,jj,ikt)
+            zwork2(ji,jj) = trn(ji,jj,ikt,jpgoc) * wsbio4(ji,jj,ikt) + trn(ji,jj,ikt,jppoc) * wsbio3(ji,jj,ikt) 
 # endif
-         END DO
-      END DO
-      zsumsedsi  = glob_sum( zwork (:,:) * e1e2t(:,:) ) * rday1
-      zsumsedpo4 = glob_sum( zwork1(:,:) * e1e2t(:,:) ) * rday1
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            ikt = mbkt(ji,jj) 
-            zwork (ji,jj) = trn(ji,jj,ikt,jpcal) * wscal (ji,jj,ikt)
-         END DO
-      END DO
-      zsumsedcal = glob_sum( zwork (:,:) * e1e2t(:,:) ) * 2.0 * rday1
-#endif
-
-      ! Then this loss is scaled at each bottom grid cell for
+            ! For calcite, burial efficiency is made a function of saturation
+            zfactcal      = MIN( excess(ji,jj,ikt), 0.2 )
+            zfactcal      = MIN( 1., 1.3 * ( 0.2 - zfactcal ) / ( 0.4 - zfactcal ) )
+            zwork3(ji,jj) = trn(ji,jj,ikt,jpcal) * wscal (ji,jj,ikt) * 2.e0 * zfactcal
+         END DO
+      END DO
+      zsumsedsi  = glob_sum( zwork1(:,:) * e1e2t(:,:) ) * r1_rday
+      zsumsedpo4 = glob_sum( zwork2(:,:) * e1e2t(:,:) ) * r1_rday
+      zsumsedcal = glob_sum( zwork3(:,:) * e1e2t(:,:) ) * r1_rday
+#endif
+
+      ! THEN this loss is scaled at each bottom grid cell for
       ! equilibrating the total budget of silica in the ocean.
       ! Thus, the amount of silica lost in the sediments equal
       ! the supply at the surface (dust+rivers)
       ! ------------------------------------------------------
+#if ! defined key_sed
+      zrivsil =  1._wp - ( sumdepsi + rivalkinput * r1_ryyss / 6. ) / zsumsedsi 
+      zrivpo4 =  1._wp - ( rivpo4input * r1_ryyss ) / zsumsedpo4 
+#endif
 
       DO jj = 1, jpj
          DO ji = 1, jpi
-            ikt = mbkt(ji,jj)
-            zfact = xstep / fse3t(ji,jj,ikt)
-            zwsbio3 = 1._wp - zfact * wsbio3(ji,jj,ikt)
-            zwsbio4 = 1._wp - zfact * wsbio4(ji,jj,ikt)
-            zwscal  = 1._wp - zfact * wscal (ji,jj,ikt)
+            ikt  = mbkt(ji,jj)
+            zdep = xstep / fse3t(ji,jj,ikt)
+            zwsbio4 = wsbio4(ji,jj,ikt) * zdep
+            zwscal  = wscal (ji,jj,ikt) * zdep
+# if defined key_kriest
+            zsiloss = trn(ji,jj,ikt,jpdsi) * zwsbio4
+# else
+            zsiloss = trn(ji,jj,ikt,jpdsi) * zwscal
+# endif
+            zcaloss = trn(ji,jj,ikt,jpcal) * zwscal
             !
-# if defined key_kriest
-            trn(ji,jj,ikt,jpdsi) = trn(ji,jj,ikt,jpdsi) * zwsbio4
-            trn(ji,jj,ikt,jpnum) = trn(ji,jj,ikt,jpnum) * zwsbio4
-            trn(ji,jj,ikt,jppoc) = trn(ji,jj,ikt,jppoc) * zwsbio3
-            trn(ji,jj,ikt,jpsfe) = trn(ji,jj,ikt,jpsfe) * zwsbio3
-# else
-            trn(ji,jj,ikt,jpdsi) = trn(ji,jj,ikt,jpdsi) * zwscal 
-            trn(ji,jj,ikt,jpgoc) = trn(ji,jj,ikt,jpgoc) * zwsbio4
-            trn(ji,jj,ikt,jppoc) = trn(ji,jj,ikt,jppoc) * zwsbio3
-            trn(ji,jj,ikt,jpbfe) = trn(ji,jj,ikt,jpbfe) * zwsbio4
-            trn(ji,jj,ikt,jpsfe) = trn(ji,jj,ikt,jpsfe) * zwsbio3
-# endif
-            trn(ji,jj,ikt,jpcal) = trn(ji,jj,ikt,jpcal) * zwscal
-         END DO
-      END DO
-
+            trn(ji,jj,ikt,jpdsi) = trn(ji,jj,ikt,jpdsi) - zsiloss
+            trn(ji,jj,ikt,jpcal) = trn(ji,jj,ikt,jpcal) - zcaloss
 #if ! defined key_sed
-      zrivsil =  1._wp - ( sumdepsi + rivalkinput * ryyss1 / 6. ) / zsumsedsi 
-      zrivalk =  1._wp - ( rivalkinput * ryyss1 ) / zsumsedcal 
-      zrivpo4 =  1._wp - ( rivpo4input * ryyss1 ) / zsumsedpo4 
+            trn(ji,jj,ikt,jpsil) = trn(ji,jj,ikt,jpsil) + zsiloss * zrivsil 
+            zfactcal = MIN( excess(ji,jj,ikt), 0.2 )
+            zfactcal = MIN( 1., 1.3 * ( 0.2 - zfactcal ) / ( 0.4 - zfactcal ) )
+            zrivalk  =  1._wp - ( rivalkinput * r1_ryyss ) * zfactcal / zsumsedcal 
+            trn(ji,jj,ikt,jptal) =  trn(ji,jj,ikt,jptal) + zcaloss * zrivalk * 2.0
+            trn(ji,jj,ikt,jpdic) =  trn(ji,jj,ikt,jpdic) + zcaloss * zrivalk
+#endif
+         END DO
+      END DO
+
       DO jj = 1, jpj
          DO ji = 1, jpi
-            ikt = mbkt(ji,jj)
-            zfact = xstep / fse3t(ji,jj,ikt)
-            zwsbio3 = zfact * wsbio3(ji,jj,ikt)
-            zwsbio4 = zfact * wsbio4(ji,jj,ikt)
-            zwscal  = zfact * wscal (ji,jj,ikt)
-            trn(ji,jj,ikt,jptal) =  trn(ji,jj,ikt,jptal) + trn(ji,jj,ikt,jpcal) * zwscal  * zrivalk * 2.0
-            trn(ji,jj,ikt,jpdic) =  trn(ji,jj,ikt,jpdic) + trn(ji,jj,ikt,jpcal) * zwscal  * zrivalk
-# if defined key_kriest
-            trn(ji,jj,ikt,jpsil) =  trn(ji,jj,ikt,jpsil) + trn(ji,jj,ikt,jpdsi) * zwsbio4 * zrivsil 
-            trn(ji,jj,ikt,jpdoc) =  trn(ji,jj,ikt,jpdoc) + trn(ji,jj,ikt,jppoc) * zwsbio3 * zrivpo4 
+            ikt  = mbkt(ji,jj)
+            zdep = xstep / fse3t(ji,jj,ikt)
+            zwsbio4 = wsbio4(ji,jj,ikt) * zdep
+            zwsbio3 = wsbio3(ji,jj,ikt) * zdep
+# if ! defined key_kriest
+            trn(ji,jj,ikt,jpgoc) = trn(ji,jj,ikt,jpgoc) - trn(ji,jj,ikt,jpgoc) * zwsbio4
+            trn(ji,jj,ikt,jppoc) = trn(ji,jj,ikt,jppoc) - trn(ji,jj,ikt,jppoc) * zwsbio3
+            trn(ji,jj,ikt,jpbfe) = trn(ji,jj,ikt,jpbfe) - trn(ji,jj,ikt,jpbfe) * zwsbio4
+            trn(ji,jj,ikt,jpsfe) = trn(ji,jj,ikt,jpsfe) - trn(ji,jj,ikt,jpsfe) * zwsbio3
+#if ! defined key_sed
+            trn(ji,jj,ikt,jpdoc) = trn(ji,jj,ikt,jpdoc) &
+               &               + ( trn(ji,jj,ikt,jpgoc) * zwsbio4 + trn(ji,jj,ikt,jppoc) * zwsbio3 ) * zrivpo4
+#endif
+
 # else
-            trn(ji,jj,ikt,jpsil) =  trn(ji,jj,ikt,jpsil) + trn(ji,jj,ikt,jpdsi) * zwscal  * zrivsil 
-            trn(ji,jj,ikt,jpdoc) =  trn(ji,jj,ikt,jpdoc)   &
-            &                     + ( trn(ji,jj,ikt,jppoc) * zwsbio3 + trn(ji,jj,ikt,jpgoc) * zwsbio4 ) * zrivpo4
+            trn(ji,jj,ikt,jpnum) = trn(ji,jj,ikt,jpnum) - trn(ji,jj,ikt,jpnum) * zwsbio4
+            trn(ji,jj,ikt,jppoc) = trn(ji,jj,ikt,jppoc) - trn(ji,jj,ikt,jppoc) * zwsbio3
+            trn(ji,jj,ikt,jpsfe) = trn(ji,jj,ikt,jpsfe) - trn(ji,jj,ikt,jpsfe) * zwsbio3
+#if ! defined key_sed
+            trn(ji,jj,ikt,jpdoc) = trn(ji,jj,ikt,jpdoc) &
+               &               + ( trn(ji,jj,ikt,jpnum) * zwsbio4 + trn(ji,jj,ikt,jppoc) * zwsbio3 ) * zrivpo4
+#endif
+
 # endif
          END DO
       END DO
-# endif
+
 
       ! Nitrogen fixation (simple parameterization). The total gain
@@ -233,5 +250,5 @@
       ! -------------------------------------------------------------
 
-      zdenitot = glob_sum( denitr(:,:,:)  * cvol(:,:,:) * xnegtr(:,:,:) ) * rdenit
+      zdenitot = glob_sum(  ( denitr(:,:,:) * rdenit + denitnh4(:,:,:) * rdenita ) * cvol(:,:,:) * xnegtr(:,:,:) )
 
       ! Potential nitrogen fixation dependant on temperature and iron
@@ -246,10 +263,12 @@
                zlim = ( 1.- xnanono3(ji,jj,jk) - xnanonh4(ji,jj,jk) )
                IF( zlim <= 0.2 )   zlim = 0.01
-               znitrpot(ji,jj,jk) = MAX( 0.e0, ( 0.6 * tgfunc(ji,jj,jk) - 2.15 ) * rday1 )   &
-# if defined key_degrad
-               &                  * facvol(ji,jj,jk)   &
-# endif
-               &                  * zlim * rfact2 * trn(ji,jj,jk,jpfer)   &
-               &                  / ( conc3 + trn(ji,jj,jk,jpfer) ) * ( 1.- EXP( -etot(ji,jj,jk) / 50.) )
+#if defined key_degrad
+               zfact = zlim * rfact2 * facvol(ji,jj,jk)
+#else
+               zfact = zlim * rfact2 
+#endif
+               znitrpot(ji,jj,jk) =  MAX( 0.e0, ( 0.6 * tgfunc(ji,jj,jk) - 2.15 ) * r1_rday )   &
+                 &                 *  zfact * trn(ji,jj,jk,jpfer) / ( concfediaz + trn(ji,jj,jk,jpfer) ) &
+                 &                 * ( 1.- EXP( -etot(ji,jj,jk) / diazolight ) )
             END DO
          END DO 
@@ -260,38 +279,38 @@
       ! Nitrogen change due to nitrogen fixation
       ! ----------------------------------------
-
       DO jk = 1, jpk
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zfact = znitrpot(ji,jj,jk) * 1.e-7
+               zfact = znitrpot(ji,jj,jk) * nitrfix
                trn(ji,jj,jk,jpnh4) = trn(ji,jj,jk,jpnh4) + zfact
+               trn(ji,jj,jk,jptal) = trn(ji,jj,jk,jptal) + rno3 * zfact
                trn(ji,jj,jk,jpoxy) = trn(ji,jj,jk,jpoxy) + zfact   * o2nit
-               trn(ji,jj,jk,jppo4) = trn(ji,jj,jk,jppo4) + 30./ 46.* zfact
-            END DO
-         END DO
+               trn(ji,jj,jk,jppo4) = trn(ji,jj,jk,jppo4) + 30. / 46. * zfact
+           !    trn(ji,jj,jk,jppo4) = trn(ji,jj,jk,jppo4) + zfact
+           END DO
+         END DO 
       END DO
 
 #if defined key_diatrc
       zfact = 1.e+3 * rfact2r
-#  if  ! defined key_iomput
-      trc2d(:,:,jp_pcs0_2d + 11) = zirondep(:,:,1)         * zfact * fse3t(:,:,1) * tmask(:,:,1)
-      trc2d(:,:,jp_pcs0_2d + 12) = znitrpot(:,:,1) * 1.e-7 * zfact * fse3t(:,:,1) * tmask(:,:,1)
-#  else
-      zwork (:,:)  =  ( zirondep(:,:,1) + ironsed(:,:,1) * rfact2 ) * zfact * fse3t(:,:,1) * tmask(:,:,1) 
-      zwork1(:,:)  =  znitrpot(:,:,1) * 1.e-7                       * zfact * fse3t(:,:,1) * tmask(:,:,1)
+#if defined key_iomput
+      zwork1(:,:)  =  ( zirondep(:,:,1) + ironsed(:,:,1) * rfact2 ) * zfact * fse3t(:,:,1) * tmask(:,:,1) 
+      zwork2(:,:)  =    znitrpot(:,:,1) * nitrif                    * zfact * fse3t(:,:,1) * tmask(:,:,1)
       IF( jnt == nrdttrc ) THEN
-         CALL iom_put( "Irondep", zwork  )  ! surface downward net flux of iron
-         CALL iom_put( "Nfix"   , zwork1 )  ! nitrogen fixation at surface
-      ENDIF
-#  endif
+          CALL iom_put( "Irondep", zwork1  )  ! surface downward net flux of iron
+          CALL iom_put( "Nfix"   , zwork2 )  ! nitrogen fixation at surface
+      ENDIF
+#else
+      trc2d(:,:,jp_pcs0_2d + 11) = zirondep(:,:,1)          * zfact * fse3t(:,:,1) * tmask(:,:,1)
+      trc2d(:,:,jp_pcs0_2d + 12) = znitrpot(:,:,1) * nitrif * zfact * fse3t(:,:,1) * tmask(:,:,1)
 #endif
       !
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
-         WRITE(charout, FMT="('sed ')")
+      IF(ln_ctl) THEN  ! print mean trends (USEd for debugging)
+         WRITE(charout, fmt="('sed ')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=trn, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
-      IF( ( wrk_not_released(2, 1,2,3) ) .OR. ( wrk_not_released(3, 2,3) ) )   &
+      ENDIF
+
+      IF( ( wrk_not_released(2, 11,12,13,14) ) .OR. ( wrk_not_released(3, 2,3) ) )   &
         &         CALL ctl_stop('p4z_sed: failed to release workspace arrays')
 
@@ -299,12 +318,11 @@
 
    SUBROUTINE p4z_sbc( kt )
-
       !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE p4z_sbc  ***
-      !!
-      !! ** Purpose :   Read and interpolate the external sources of 
+      !!                  ***  routine p4z_sbc  ***
+      !!
+      !! ** purpose :   read and interpolate the external sources of 
       !!                nutrients
       !!
-      !! ** Method  :   Read the files and interpolate the appropriate variables
+      !! ** method  :   read the files and interpolate the appropriate variables
       !!
       !! ** input   :   external netcdf files
@@ -314,44 +332,47 @@
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
 
-      !! * Local declarations
-      INTEGER :: imois, i15, iman 
-      REAL(wp) :: zxy
+      !! * local declarations
+      INTEGER  :: ji,jj 
+      REAL(wp) :: zcoef
 
       !!---------------------------------------------------------------------
 
-      ! Initialization
-      ! --------------
-
-      i15 = nday / 16
-      iman  = INT( raamo )
-      imois = nmonth + i15 - 1
-      IF( imois == 0 ) imois = iman
-
-      ! Calendar computation
-      IF( kt == nit000 .OR. imois /= nflx1 ) THEN
-
-         IF( kt == nit000 )  nflx1  = 0
-
-         ! nflx1 number of the first file record used in the simulation
-         ! nflx2 number of the last  file record
-
-         nflx1 = imois
-         nflx2 = nflx1 + 1
-         nflx1 = MOD( nflx1, iman )
-         nflx2 = MOD( nflx2, iman )
-         IF( nflx1 == 0 )   nflx1 = iman
-         IF( nflx2 == 0 )   nflx2 = iman
-         IF(lwp) WRITE(numout,*) 
-         IF(lwp) WRITE(numout,*) ' p4z_sbc : first record file used nflx1 ',nflx1
-         IF(lwp) WRITE(numout,*) ' p4z_sbc : last  record file used nflx2 ',nflx2
-
-      ENDIF
-
-      ! 3. at every time step interpolation of fluxes
-      ! ---------------------------------------------
-
-      zxy = FLOAT( nday + 15 - 30 * i15 ) / 30
-      dust(:,:) = ( (1.-zxy) * dustmo(:,:,nflx1) + zxy * dustmo(:,:,nflx2) )
-
+      ! Compute dust at nit000 or only if there is more than 1 time record in dust file
+      IF( ln_dust ) THEN
+         IF( kt == nit000 .OR. ( kt /= nit000 .AND. ntimes_dust > 1 ) ) THEN
+            CALL fld_read( kt, 1, sf_dust )
+            dust(:,:) = sf_dust(1)%fnow(:,:,1)
+         ENDIF
+      ENDIF
+
+      ! N/P and Si releases due to coastal rivers
+      ! Compute river at nit000 or only if there is more than 1 time record in river file
+      ! -----------------------------------------
+      IF( ln_river ) THEN
+         IF( kt == nit000 .OR. ( kt /= nit000 .AND. ntimes_riv > 1 ) ) THEN
+            CALL fld_read( kt, 1, sf_riverdic )
+            CALL fld_read( kt, 1, sf_riverdoc )
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zcoef = ryyss * cvol(ji,jj,1) 
+                  cotdep(ji,jj) =   sf_riverdic(1)%fnow(ji,jj,1)                                  * 1E9 / ( 12. * zcoef + rtrn )
+                  rivinp(ji,jj) = ( sf_riverdic(1)%fnow(ji,jj,1) + sf_riverdoc(1)%fnow(ji,jj,1) ) * 1E9 / ( 31.6* zcoef + rtrn )
+               END DO
+            END DO
+         ENDIF
+      ENDIF
+
+      ! Compute N deposition at nit000 or only if there is more than 1 time record in N deposition file
+      IF( ln_ndepo ) THEN
+         IF( kt == nit000 .OR. ( kt /= nit000 .AND. ntimes_ndep > 1 ) ) THEN
+            CALL fld_read( kt, 1, sf_ndepo )
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  nitdep(ji,jj) = 7.6 * sf_ndepo(1)%fnow(ji,jj,1) / ( 14E6 * ryyss * fse3t(ji,jj,1) + rtrn )
+               END DO
+            END DO
+         ENDIF
+      ENDIF
+      !
    END SUBROUTINE p4z_sbc
 
